#directories
CSOU = SOURCE/SHARED
SSOU = SOURCE/SIMULAT
RSOU = SOURCE/READNET
EDT = EDIT
OBJ = ../$(GSPN2BINS)/2bin
INC = INCLUDE
TRS = TRANSL

#commands
COMP = gcc  -c -O3 -w -o
LINK = gcc  -w -O3 -o

LFLAGS = -lm -ll
#LFLAGS = -lm -lnsl -ll

#files groups
EXECUTABLES  =  WNSIM
T_INCLUDES = ${INC}/const.cs \
	     ${INC}/struct.h \
	     ${INC}/var_ext.h \
	     ${INC}/decl.h \
	     ${INC}/fun_ext.h \
	     ${INC}/macros.h
T_OBJECTS = ${OBJ}/CSCOLORED_net.o \
	    ${OBJ}/CSCOLORED_def.o \
	    ${OBJ}/CSCOLORED_grammar.o \
	    ${OBJ}/CSCOLORED_service.o \
	    ${OBJ}/CSCOLORED_token.o \
	    ${OBJ}/CSCOLORED_eng_wn.o \
	    ${OBJ}/CSCOLORED_dimensio.o \
	    ${OBJ}/CSCOLORED_errors.o \
	    ${OBJ}/CSCOLORED_common.o \
	    ${OBJ}/CSCOLORED_random.o \
	    ${OBJ}/CSCOLORED_stat.o \
            ${OBJ}/CSCOLORED_report.o \
            ${OBJ}/CSCOLORED_read_arc.o \
            ${OBJ}/CSCOLORED_read_t_c.o \
            ${OBJ}/CSCOLORED_read_t_s.o \
            ${OBJ}/CSCOLORED_wn_yac.o \
	    ${OBJ}/CSCOLORED_engine.o \
	    ${OBJ}/CSCOLORED_distribu.o \
            ${OBJ}/CSCOLORED_enabling.o \
	    ${OBJ}/CSCOLORED_fire.o\
	    ${OBJ}/CSCOLORED_increm.o\
	    ${OBJ}/CSCOLORED_presel.o\
	    ${OBJ}/CSCOLORED_shared1.o\
	    ${OBJ}/CSCOLORED_shared2.o\
	    ${OBJ}/CSCOLORED_outdom.o\
	    ${OBJ}/CSCOLORED_precheck.o \
	    ${OBJ}/CSCOLORED_flush.o \
	    ${OBJ}/CSCOLORED_degree.o
T_SOURCES = ${CSOU}/service.c \
	    ${CSOU}/token.c \
	    ${CSOU}/dimensio.c \
	    ${CSOU}/errors.c \
	    ${CSOU}/common.c \
	    ${CSOU}/enabling.c	\
	    ${CSOU}/fire.c\
	    ${CSOU}/shared1.c\
	    ${CSOU}/shared2.c\
	    ${CSOU}/outdom.c\
	    ${CSOU}/report.c\
	    ${CSOU}/precheck.c \
	    ${CSOU}/flush.c \
	    ${CSOU}/degree.c \
	    ${SSOU}/eng_wn.c \
	    ${SSOU}/engine.c \
	    ${SSOU}/distribu.c \
	    ${SSOU}/increm.c\
	    ${SSOU}/presel.c\
	    ${SSOU}/random.c\
	    ${SSOU}/stat.c\
	    ${RSOU}/read_arc.c \
	    ${RSOU}/read_t_c.c \
	    ${RSOU}/read_t_s.c \
	    ${RSOU}/wn_yac.c
T_LEX = ${TRS}/wn.lex \
	${TRS}/net.lex \
	${TRS}/def.lex
T_YACC = ${TRS}/wn.yac

#general rules
#${EXECUTABLES} : ${T_INCLUDES} ${T_LEX} ${T_YACC} {T_SOURCES}

${OBJ}/WNSIM : ${T_INCLUDES} ${T_OBJECTS} ${T_LEX} ${T_YACC} ${CSOU}/main.c
	${LINK} ${OBJ}/WNSIM ${CSOU}/main.c ${T_OBJECTS} ${LFLAGS}

${OBJ}/CSCOLORED_outdom.o : ${CSOU}/outdom.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_outdom.o ${CSOU}/outdom.c

${OBJ}/CSCOLORED_shared1.o : ${CSOU}/shared1.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_shared1.o ${CSOU}/shared1.c

${OBJ}/CSCOLORED_shared2.o : ${CSOU}/shared2.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_shared2.o ${CSOU}/shared2.c

${OBJ}/CSCOLORED_precheck.o : ${CSOU}/precheck.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_precheck.o ${CSOU}/precheck.c

${OBJ}/CSCOLORED_fire.o : ${CSOU}/fire.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_fire.o ${CSOU}/fire.c

${OBJ}/CSCOLORED_degree.o : ${CSOU}/degree.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_degree.o ${CSOU}/degree.c

${OBJ}/CSCOLORED_report.o : ${CSOU}/report.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_report.o ${CSOU}/report.c
       
${OBJ}/CSCOLORED_flush.o : ${CSOU}/flush.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_flush.o ${CSOU}/flush.c
       
${OBJ}/CSCOLORED_common.o : ${CSOU}/common.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_common.o ${CSOU}/common.c
       
${OBJ}/CSCOLORED_errors.o : ${CSOU}/errors.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_errors.o ${CSOU}/errors.c
       
${OBJ}/CSCOLORED_dimensio.o : ${CSOU}/dimensio.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_dimensio.o ${CSOU}/dimensio.c
       
${OBJ}/CSCOLORED_enabling.o : ${CSOU}/enabling.c ${T_INCLUDES} ${INC}/shared.h
	${COMP} ${OBJ}/CSCOLORED_enabling.o ${CSOU}/enabling.c
       
${OBJ}/CSCOLORED_token.o : ${CSOU}/token.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_token.o ${CSOU}/token.c
       
${OBJ}/CSCOLORED_service.o : ${CSOU}/service.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_service.o ${CSOU}/service.c
       
${OBJ}/CSCOLORED_engine.o : ${SSOU}/engine.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_engine.o ${SSOU}/engine.c
       
${OBJ}/CSCOLORED_eng_wn.o : ${SSOU}/eng_wn.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_eng_wn.o ${SSOU}/eng_wn.c
       
${OBJ}/CSCOLORED_distribu.o : ${SSOU}/distribu.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_distribu.o ${SSOU}/distribu.c
       
${OBJ}/CSCOLORED_stat.o : ${SSOU}/stat.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_stat.o ${SSOU}/stat.c
       
${OBJ}/CSCOLORED_random.o : ${SSOU}/random.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_random.o ${SSOU}/random.c
       
${OBJ}/CSCOLORED_increm.o : ${SSOU}/increm.c ${T_INCLUDES} ${INC}/shared.h
	${COMP} ${OBJ}/CSCOLORED_increm.o ${SSOU}/increm.c

${OBJ}/CSCOLORED_presel.o : ${SSOU}/presel.c ${T_INCLUDES} ${INC}/shared.h
	${COMP} ${OBJ}/CSCOLORED_presel.o ${SSOU}/presel.c

${OBJ}/CSCOLORED_wn_yac.o : ${RSOU}/wn_yac.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_wn_yac.o ${RSOU}/wn_yac.c
       
${OBJ}/CSCOLORED_read_arc.o : ${RSOU}/read_arc.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_read_arc.o ${RSOU}/read_arc.c
       
${OBJ}/CSCOLORED_read_t_s.o : ${RSOU}/read_t_s.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_read_t_s.o ${RSOU}/read_t_s.c
       
${OBJ}/CSCOLORED_read_t_c.o : ${RSOU}/read_t_c.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_read_t_c.o ${RSOU}/read_t_c.c
       
${OBJ}/CSCOLORED_grammar.o : SOURCE/grammar.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_grammar.o SOURCE/grammar.c

${OBJ}/CSCOLORED_net.o : SOURCE/net.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_net.o SOURCE/net.c

${OBJ}/CSCOLORED_def.o : SOURCE/def.c ${T_INCLUDES}
	${COMP} ${OBJ}/CSCOLORED_def.o SOURCE/def.c

SOURCE/lex.c : ${TRS}/wn.lex
	lex ${TRS}/wn.lex
	mv lex.yy.c SOURCE/lex.c
	ed SOURCE/lex.c < ${EDT}/ed_lex
	

SOURCE/grammar.c : ${TRS}/wn.yac SOURCE/lex.c ${T_INCLUDES}
	yacc ${TRS}/wn.yac
	mv y.tab.c SOURCE/grammar.c
	ed SOURCE/grammar.c < ${EDT}/ed_gram

SOURCE/net.c : ${TRS}/net.lex ${T_INCLUDES}
	lex ${TRS}/net.lex
	mv lex.yy.c SOURCE/net.c
	ed SOURCE/net.c < ${EDT}/ed_net

SOURCE/def.c : ${TRS}/def.lex ${T_INCLUDES}
	lex ${TRS}/def.lex
	mv lex.yy.c SOURCE/def.c
	ed SOURCE/def.c < ${EDT}/ed_def
