# include <stdio.h>
# include "../../INCLUDE/const.h"
# include "../../INCLUDE/struct.h"
# include "../../INCLUDE/var_ext.h"
# include "../../INCLUDE/macros.h"

#define MAX_PREDICATE_STACK 100

extern char *emalloc();
extern char *ecalloc();
extern double cur_time;

#ifdef DEBUG_malloc
static int event_mall = 0;
static int event_push = 0;
static int event_pop = 0;
#endif

static Event_p * event_free = NULL;  /* Array di free list per gli eventi */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
int compare_input_event_id(ev_1,ev_2,tr)
 Event_p ev_1;
 Event_p ev_2;
 int tr;    
 {/* Init compare_input_event_id */
  int ii , equal = TRUE, ret_value = UNKNOWN;

  for(ii = tabt[tr].comp_num ; ii && equal ; ii--)
   {/* Per ogni componente del dominio della transizione */
    if(tabt[tr].comp_type[ii - 1] == IN)
     {   
      if(ev_1->npla[ii - 1] != UNKNOWN && ev_2->npla[ii - 1] != UNKNOWN)
       {/* Componenti fissate */
        equal = (ev_1->npla[ii - 1] == ev_2->npla[ii - 1]);
#ifdef SYMBOLIC
        equal &= (ev_1->split[ii - 1] == ev_2->split[ii - 1]);
#endif   
       }/* Componenti fissate */
     }
   }/* Per ogni componente del dominio della transizione */
  if(equal)
   {/* Ricerca con successo */
    ret_value = EQUAL_TO;
   }/* Ricerca con successo */
  return(ret_value);
 }/* End compare_input_event_id */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void initialize_free_event_list()
 {/* Init initialize_free_event_list */
  int ii;

  event_free = (Event_p *)ecalloc(ntr,sizeof(Event_p));
  for(ii = 0; ii < ntr ; ii++)
   event_free[ii] = NULL;
 }/* Init initialize_free_event_list */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void dispose_old_event(ptr)
 Event_p ptr;
 {/* Init dispose_old_event */
  int tr = ptr->trans;

  ptr->next = event_free[tr];
  event_free[tr] = ptr;
#ifdef DEBUG_malloc
  event_push++;
#endif
 }/* End dispose_old_event */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
Event_p get_new_event(tr)
 int tr;
 {/* Init get_new_event */
  int i;
  Event_p ptr;

#ifdef DEBUG_malloc
  event_pop++;
#endif
  if(event_free[tr] == NULL)
   {
    ptr = (Event_p)emalloc(sizeof(struct ENABLING));
    if(tabt[tr].comp_num)
     {
      ptr->npla = (int *)ecalloc(tabt[tr].comp_num,sizeof(int));
#ifdef SYMBOLIC
      ptr->split = (int *)ecalloc(tabt[tr].comp_num,sizeof(int));
#endif
     }
    ptr->trans = tr;
#ifdef DEBUG_malloc
    event_mall++;
#endif
   }
  else
   {
    ptr = event_free[tr];
    event_free[tr] = event_free[tr]->next;
   }
  ptr->next=NULL;
#ifdef SIMULATION
  ptr->t_next=ptr->t_prev=NULL;
  ptr->e_prev=ptr->e_next=NULL;
  ptr->last_sched_desched_time=ptr->residual_sched_time=-1;
  ptr->creation_time=cur_time;
#endif
  if(IS_IMMEDIATE(tr))
   ptr->enabling_degree = 1;
  else
   {/* Transizione temporizzata */
    if(IS_INFINITE_SERVER(tr))
     ptr->enabling_degree = MAX_INT;
    else
     ptr->enabling_degree = tabt[tr].no_serv;
   }/* Transizione temporizzata */
#ifdef SYMBOLIC
  ptr->ordinary_instances = UNKNOWN;
#endif
  for(i=tabt[tr].comp_num;i;i--)
   {
    ptr->npla[i-1]=UNKNOWN;
#ifdef SYMBOLIC
    ptr->split[i-1]=UNKNOWN;
#endif
   }
  return(ptr);
 }/* End get_new_event */

#ifdef DEBUG_malloc
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void out_event_info()
 {/* Init out_event_info */
  fprintf(stdout,"--------------- EVENT NOTICE STRUCTURE ------------------\n");
  fprintf(stdout,"MALLOC %d\nPUSH %d\nPOP %d\n"
	 ,event_mall,event_push,event_pop);
 }/* End out_event_info */
#endif

/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
Event_p next_instance(pt)
 Event_p pt;
 {/* Init next_instance */
  Event_p ret_ptr;

  ret_ptr=pt->next;
  dispose_old_event(pt);
  return(ret_ptr);
 }/* End next_instance */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void copy_event(dst,src)
 Event_p dst;
 Event_p src;
 {/* Init copy_event */
  int i;

  for(i=tabt[src->trans].comp_num;i;i--)
   {
    dst->npla[i-1]=src->npla[i-1];
#ifdef SYMBOLIC
    dst->split[i-1]=src->split[i-1];
#endif
   }
  dst->trans = src->trans;
  dst->enabling_degree = src->enabling_degree;
 }/* End copy_event */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
int lesser(n1,n2)
 int n1;
 int n2;
 {/* Init lesser */
  return(n1<n2);
 }/* End lesser */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
int greater(n1,n2)
 int n1;
 int n2;
 {/* Init greater */
  if(n2>0)
   return(n1>=n2);
  else
   return(FALSE);
 }/* End greater */
#ifdef SYMBOLIC
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
int get_object_from_dynamic(cl,ds)
 int cl;
 int ds;
 {/* Init get_object_from_dynamic */
  int ss, ds_ind, ret_value = UNKNOWN;

  ss = get_static_subclass(cl,ds);
  ret_value = GET_STATIC_OFFSET(cl,ss);
  for(ds_ind = 0 ; ds_ind < ds ; ds_ind++)
   ret_value += GET_CARD_BY_TOTAL(cl,ss,ds_ind);
ret:return(ret_value);
 }/* End get_object_from_dynamic */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
int get_dynamic_from_object(cl,obj)
 int cl;
 int obj;
 {/* Init get_dynamic_from_object */
  int ss , dtot = 0 , ret_value = UNKNOWN, ds;
  
  for(ss = 0 ; ss < tabc[cl].sbc_num ; ss++)
   for(ds = 0; ds < GET_NUM_SS(cl,ss) ; ds++)
    {
     dtot += GET_CARD_BY_TOTAL(cl,ss,ds);
     if(obj < dtot)
      {
       ret_value = GET_STATIC_OFFSET(cl,ss) + ds;
       goto ret;
      }
    }
ret:return(ret_value);
 }/* End get_dynamic_from_object */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
int get_dynamic_from_total(cl,ds)
 int cl;
 int ds;
 {/* Init get_dynamic_from_total */
  int ss , dtot = 0 , ret_value = UNKNOWN, diff;
  
  for(ss = 0, diff = ds ; ss < tabc[cl].sbc_num ; ss++)
   {
    dtot += GET_NUM_SS(cl,ss);
    if(ds < dtot)
     {
      ret_value = GET_STATIC_OFFSET(cl,ss) + diff;
      goto ret;
     }
    diff -= GET_NUM_SS(cl,ss);
   }
ret:return(ret_value);
 }/* End get_dynamic_from_total */
#endif
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
int get_static_subclass(cl,dsc)
 int cl;
 int dsc;
 {/* Init get_static_subclass */
  int i , dtot = 0 , ret_value = UNKNOWN;
  
  if(dsc != UNKNOWN)
   {/* Elemento noto */
    for(i = 0 ; i < tabc[cl].sbc_num ; i++)
     {
      dtot += tabc[cl].sbclist[i].card;
      if(dsc < dtot)
       {
	ret_value = i;
	goto ret;
       }
     }
   }/* Elemento noto */
ret:return(ret_value);
 }/* End get_static_subclass */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
int optimized_nextvec(cartes_ptr,comp,base)
 Cart_p cartes_ptr;
 int comp;
 int *base;
 {/* Init optimized_nextvec */
  int r,flag;

  if(comp)
   {
    r = 0;
    do
     {
      flag = TRUE;
      if(cartes_ptr->low[r] + 1 > cartes_ptr->up[r])
       {
        cartes_ptr->low[r] = base[r];
        r++;
        flag = FALSE;
       }
      else
       cartes_ptr->low[r]++;
     }
    while((r < comp) && (!flag));
    if(r < comp)
     return(TRUE);
    else
     return(FALSE);
   }
  else
   return(FALSE);
 }/* End optimized_nextvec */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
int nextvec(cartes_ptr,comp)
 Cart_p cartes_ptr;
 int comp;
 {/* Init nextvec */
  int r,flag;

  if(comp)
   {
    r = 0;
    do
     {
      flag = TRUE;
      if(cartes_ptr->low[r] + 1 > cartes_ptr->up[r])
       {
        cartes_ptr->low[r] = 0;
        r++;
        flag = FALSE;
       }
      else
       cartes_ptr->low[r]++;
     }
    while((r < comp) && (!flag));
    if(r < comp)
     return(TRUE);
    else
     return(FALSE);
   }
  else
   return(FALSE);
 }/* End nextvec */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
int nextvec_with_fix(cartes_ptr,comp,fix)
 Cart_p cartes_ptr;
 int comp;
 int fix[MAX_DOMAIN];
 {/* Init nextvec_with_fix */
  int r,flag;

  if(comp)
   {
    r = 0;
    if(r != comp)
     {
      do
       {
	flag = TRUE;
	if(cartes_ptr->low[r] + 1 > cartes_ptr->up[r])
	 {
	  if( !fix[r] )
	   cartes_ptr->low[r] = 0;
	  r++;
	  flag = FALSE;
	 }
	else
	 cartes_ptr->low[r]++;
       }
      while((r<comp)&&(!flag));
     }
    if(r<comp)
     return(TRUE);
    else
     return(FALSE);
   }
  else
   return(FALSE);
 }/* End nextvec_with_fix */

/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
int get_obj_dist(ob1,ob2,cl)
 int ob1;
 int ob2;
 int cl;
 {/* Init get_obj_dist */
  int dist;

  if(ob1<=ob2)
   dist=ob2-ob1;
  else
   dist=tabc[cl].card-(ob1-ob2);
  return(dist);
 }/* End get_obj_dist */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
int get_prec(cl,ds)
 int cl;
 int ds;
 {/* Init get_prec */
  int prec;

  if(ds==0)
   prec=tabc[cl].card-1;
  else
   prec=ds-1;
  return(prec);
 }/* End get_prec */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
int get_obj_off(sb,cl)
 int sb;
 int cl;
 {/* Init get_obj_off */
  int ii,card = 0;

  for(ii=0;ii<sb;ii++)
   card+=tabc[cl].sbclist[ii].card;
  return(card);
 }/* End get_obj_off */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
int verify_predicate_constraint(code,ev_p)
 Pred_p code;
 Event_p ev_p;
 {/* Init verify_predicate_constraint */
 int tr = GET_TRANSITION_INDEX(ev_p);
 int sp = -1,end=FALSE;
 int i1,i2,cl1,cl2,oc1,oc2,o1,o2,st[MAX_PREDICATE_STACK];
 int p1,p2,d1,d2;
 Pred_p c;

 if(code==NULL)
  return(TRUE);
 c = code;
 for(;!end;)
  {/* Ciclo di valutazione */
   i1 = c->type;
   cl1 = c->col_ind;
   oc1 = c->occ - 1;
   c = c->next;
   switch(i1)
    {/* Decodifica istruzione */
     case TYPEAND :
	  {/* AND logico */
	   sp--;
	   st[sp] &= st[sp+1];
	   break;
	  }/* AND logico */
     case TYPEOR :
	  {/* OR logico */
	   sp--;
	   st[sp] |= st[sp+1];
	   break;
	  }/* OR logico */
     case TYPEEND :
	  {/* Fine codice predicato */
	   end = TRUE;
	   break;
	  }/* Fine codice predicato */
     case TYPEDIST   :
	  {/* #(X,Y)< > = #(H,K) */
	   p1 = tabt[tr].off[cl1] + oc1;
	   cl2 = c->col_ind;
	   oc2 = c->occ - 1;
	   p2 = tabt[tr].off[cl2] + oc2;
	   o1 = ev_p->npla[p1];
	   o2 = ev_p->npla[p2];
	   if (o1!=UNKNOWN && o2!=UNKNOWN)
	    {/* Calcolo prima distanza */
	     d1 = get_obj_dist(o1,o2,cl2);
	     cl1 = c->next->col_ind;
	     oc1 = c->next->occ - 1;
	     p1 = tabt[tr].off[cl1] + oc1;
	     cl2 = c->next->next->col_ind;
	     oc2 = c->next->next->occ - 1;
	     p2 = tabt[tr].off[cl2] + oc2;
	     o1 = ev_p->npla[p1];
	     o2 = ev_p->npla[p2];
	     if(o1!=UNKNOWN && o2!=UNKNOWN)
	      {/* Calcolo seconda distanza */
	       d2 = get_obj_dist(o1,o2,cl2);
	       i2 = c->next->next->type;
	       switch(i2)
		{/* Tipo di codice */
		 case TYPEEQ :
		      {/* # = # */
		       st[++sp]=(d1==d2 ? TRUE : FALSE);
		       break;
		      }/* # = # */
		 case TYPELESS :
		      {/* # < # */
		       st[++sp]=(d1<d2 ? TRUE : FALSE);
		       break;
		      }/* # < # */
		 case TYPEGREAT :
		      {/* # > # */
		       st[++sp]=(d1>d2 ? TRUE : FALSE);
		       break;
		      }/* # > # */
		}/* Tipo di codice */
	      }/* Calcolo seconda distanza */
	     else
	      st[++sp]=TRUE;
	    }/* Calcolo prima distanza */
	   else
	    st[++sp]=TRUE;
	   c = c->next->next->next;
	   break;
	  }/* #(X,Y)< > = #(H,K) */
     case TYPED   :
	  {/* d(X)=d(Y) ... d(X)=# d(X)<>d(Y) ... d(X)<># */
	   p1 = tabt[tr].off[cl1] + oc1;
	   if((o1=get_static_subclass(cl1,ev_p->npla[p1]))!=UNKNOWN)
	    {/* Oggetto istanziato */
	     i2 = c->type;
	     if(i2==TYPEDEQ || i2==TYPEDNE)
	      {/* Predicato tipo d(x)=d(y) oppure d(x)<>d(y) */
	       cl2 = c->col_ind;
	       oc2 = c->occ - 1;
	       p2 = tabt[tr].off[cl2] + oc2;
	       o2 = get_static_subclass(cl2,ev_p->npla[p2]);
	      }/* Predicato tipo d(x)=d(y) oppure d(x)<>d(y) */
	     else
	      {/* Predicato tipo d(x)=STATIC */
	       o2 = atoi(c->fun_name);
	      }/* Predicato tipo d(x)=STATIC */
	     if(o2!=UNKNOWN)
	      if(i2==TYPEDEQ || i2==TYPENUMEQ)
	       st[++sp]=(o1==o2 ? TRUE : FALSE);
	      else
	       st[++sp]=(o1!=o2 ? TRUE : FALSE);
	     else
	      st[++sp]=TRUE;
	    }/* Oggetto istanziato */
	   else
	    st[++sp]=TRUE;
	   c = c->next;
	   break;
	  }/* d(X)=d(Y) ... d(X)=# d(X)<>d(Y) ... d(X)<># */
     case TYPEX	  :
	  {/* X=Y ... X=!Y ... X<>Y ... X<>!Y ...
	      X=^Y ... X<>^Y ... X<Y ... X>Y	  */
	   p1 = tabt[tr].off[cl1] + oc1;
	   cl2 = c->col_ind;
	   oc2 = c->occ - 1;
	   p2 = tabt[tr].off[cl2] + oc2;
	   o1 = ev_p->npla[p1];
	   o2 = ev_p->npla[p2];
#ifdef SYMBOLIC
	   if(IS_UNORDERED(cl2))
	    {/* Non split a fire time */
	     o1 = ev_p->split[p1];
	     o2 = ev_p->split[p2];
	    }/* Non split a fire time */
#endif
	   if (o1!=UNKNOWN && o2!=UNKNOWN)
	    {
	     i2 = c->type;
	     switch(i2)
	      {/* Tipo di codice */
	       case TYPEXEQ :
		    {/* X=Y */
		     st[++sp]=(o1==o2 ? TRUE : FALSE);
		     break;
		    }/* X=Y */
	       case TYPEPEQ :
		    {/* X=^Y */
		     st[++sp]=(o1==get_prec(cl2,o2) ? TRUE : FALSE);
		     break;
		    }/* X=^Y */
	       case TYPENEQ :
		    {/* X=!Y */
		     st[++sp]=(o1==(o2+1)%tabc[cl2].card ? TRUE : FALSE);
		     break;
		    }/* X=!Y */
	       case TYPEXNE :
		    {/* X<>Y */
		     st[++sp]=(o1!=o2 ? TRUE : FALSE);
		     break;
		    }/* X<>Y */
	       case TYPEPNE :
		    {/* X<>^Y */
		     st[++sp]=(o1!=get_prec(cl2,o2) ? TRUE : FALSE);
		     break;
		    }/* X<>^Y */
	       case TYPENNE :
		    {/* X<>!Y */
		     st[++sp]=(o1!=(o2+1)%tabc[cl2].card ? TRUE : FALSE);
		     break;
		    }/* X<>!Y */
	       case TYPELESS :
		    {/* X<Y */
		     st[++sp]=(o1<o2 ? TRUE : FALSE);
		     break;
		    }/* X<Y */
	       case TYPEGREAT :
		    {/* X>Y */
		     st[++sp]=(o1>o2 ? TRUE : FALSE);
		     break;
		    }/* X>Y */
	     }/* Tipo di codice */
	    }
	   else
	    st[++sp]=TRUE;
	   c = c->next;
	   break;
	  }/* X=Y ... X=!Y ... X<>Y ... X<>!Y ...
	      X=^Y ... X<>^Y ... X<Y ... X>Y */
     default :
	  {
	   return(TRUE);
	   break;
	  }
    }/* Decodifica istruzione */
  }/* Ciclo di valutazione */
 return(st[sp]);
}/* End verify_predicate_constraint */
