#include <stdio.h>
#include "../../INCLUDE/const.h"
#include "../../INCLUDE/struct.h"
#include "../../INCLUDE/var_ext.h"
#include "../../INCLUDE/macros.h"
#include <math.h>

#ifdef SIMULATION
extern double negexp();

extern double cur_time;

#ifdef DEBUG_malloc
static int rem_time_mall = 0;
static int rem_time_push = 0;
static int rem_time_pop = 0;

static int times_mall = 0;
static int times_push = 0;
static int times_pop = 0;
#endif

static Rem_time_p * rem_time_free = NULL;
	  /* Array di free list per i tempi di servizio	*/
static Time_p times_free = NULL;

#define K_ERLANG 2 
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void initialize_free_rem_time_list()
 {/* Init initialize_free_rem_time_list */
  int ii;

  rem_time_free = (Rem_time_p *)ecalloc(ntr,sizeof(Rem_time_p));
  for(ii = 0; ii < ntr ; ii++)
   rem_time_free[ii] = NULL;
 }/* Init initialize_free_rem_time_list */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void initialize_free_times_list()
 {/* Init initialize_free_times_list */
  times_free = NULL;
 }/* Init initialize_free_times_list */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static void initialize_rem_time_fields(rem_ptr)
 Rem_time_p rem_ptr;
 {/* Init initialize_rem_time_fields */
  rem_ptr->degree = 0;
  rem_ptr->times = NULL;
  rem_ptr->next = NULL;
 }/* End initialize_rem_time_fields */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static void push_rem_time(rem_ptr,tr)
 Rem_time_p rem_ptr;
 int tr;
 {/* Init push_rem_time */
  rem_ptr->next = rem_time_free[tr];
  rem_time_free[tr] = rem_ptr;
#ifdef DEBUG_malloc
  rem_time_push++;
#endif
 }/* End push_rem_time */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static Rem_time_p pop_rem_time(tr)
 int tr;
 {/* Init pop_rem_time */
  Rem_time_p ret_ptr = NULL;

#ifdef DEBUG_malloc
  rem_time_pop++;
#endif
  if(rem_time_free[tr] == NULL)
   {
    ret_ptr = (Rem_time_p)emalloc(sizeof(struct DISTRIBUTIONS));
    if(tabt[tr].comp_num)
     ret_ptr->instance = (int *)ecalloc(tabt[tr].comp_num,sizeof(int));
#ifdef DEBUG_malloc
    rem_time_mall++;
#endif
   }
  else
   {
    ret_ptr = rem_time_free[tr];
    rem_time_free[tr] = rem_time_free[tr]->next;
   }
  initialize_rem_time_fields(ret_ptr);
  return(ret_ptr);
 }/* End pop_rem_time */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static void initialize_times_fields(time_ptr)
 Time_p time_ptr;
 {/* Init initialize_times_fields */
  time_ptr->time = 0.0;
  time_ptr->next = NULL;
 }/* End initialize_times_fields */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static void push_times(time_ptr)
 Time_p time_ptr;
 {/* Init push_times */
  time_ptr->next = times_free;
  times_free = time_ptr;
#ifdef DEBUG_malloc
  times_push++;
#endif
 }/* End push_times */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static Time_p pop_times()
 {/* Init pop_times */
  Time_p ret_ptr = NULL;

#ifdef DEBUG_malloc
  times_pop++;
#endif
  if(times_free == NULL)
   {
    ret_ptr = (Time_p)emalloc(sizeof(struct TIMES));
#ifdef DEBUG_malloc
    times_mall++;
#endif
   }
  else
   {
    ret_ptr = times_free;
    times_free = times_free->next;
   }
  initialize_times_fields(ret_ptr);
  return(ret_ptr);
 }/* End pop_times */
#ifdef DEBUG_malloc
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void out_times_info()
 {/* Init out_times_info */
  fprintf(stdout,"------------- REMAINING FIRING TIMES STRUCTURE ------------\n");
  fprintf(stdout,"MALLOC %d\nPUSH %d\nPOP %d\n"
		 ,rem_time_mall,rem_time_push,rem_time_pop);
  fprintf(stdout,"------------------- TIMES STRUCTURE ----------------\n");
  fprintf(stdout,"MALLOC %d\nPUSH %d\nPOP %d\n"
		 ,times_mall,times_push,times_pop);
 }/* End out_times_info */
#endif
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static int match_identity(rem_ptr,ev_p)
 Rem_time_p rem_ptr;
 Event_p ev_p;
 {/* Init match identity */
  int tr = GET_TRANSITION_INDEX(ev_p);
  int comp = GET_TRANSITION_COMPONENTS(tr);
  int ret_value = TRUE;
  int ii;

  for( ii = comp ; ii && ret_value ; ii--)
   ret_value = (ev_p->npla[ii - 1] == rem_ptr->instance[ii - 1]);
  return(ret_value);
 }/* End match identity */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static void copy_instance_identity(rem_ptr,ev_p)
 Rem_time_p rem_ptr;
 Event_p ev_p;
 {/* Init copy_instance_identity */
  int tr = GET_TRANSITION_INDEX(ev_p);
  int comp = GET_TRANSITION_COMPONENTS(tr);
  int ii;

  for( ii = comp ; ii ; ii--)
   rem_ptr->instance[ii - 1] = ev_p->npla[ii - 1] ;
 }/* End copy_instance_identity */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static void get_instance_info(ev_p,info_ptr)
 Event_p ev_p;
 Rem_time_info_p info_ptr;
 {/* Init get_instance_info */
  int tr = GET_TRANSITION_INDEX(ev_p);

  Rem_time_p scan_ptr = GET_TRANSITION_TIMES_LIST(tr);
  Rem_time_p prev_ptr = NULL;

  for(; scan_ptr != NULL ; )
   {/* Per ogni istanza */
    if(match_identity(scan_ptr,ev_p))
     {/* Trovata la istanza */
      info_ptr->prv = prev_ptr;
      info_ptr->pos = scan_ptr;
      break;
     }/* Trovata la istanza */
    prev_ptr = scan_ptr;
    scan_ptr = NEXT_RESIDUAL(scan_ptr);
   }/* Per ogni istanza */
 }/* End get_instance_info */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
Rem_time_p get_instance_offset_without_malloc (ev_p)
 Event_p ev_p;
 {/* Init get_instance_offset_without_malloc */
  int tr = GET_TRANSITION_INDEX(ev_p);
  int found = FALSE;

  Rem_time_p scan_ptr = GET_TRANSITION_TIMES_LIST(tr);
  Rem_time_p ret_ptr = NULL;

  for(; scan_ptr != NULL && !found; )
   {/* Per ogni istanza */
    if(match_identity(scan_ptr,ev_p))
     {/* Trovata la istanza */
      found = TRUE;
      ret_ptr = scan_ptr;
     }/* Trovata la istanza */
    scan_ptr = NEXT_RESIDUAL(scan_ptr);
   }/* Per ogni istanza */
  return(ret_ptr);
 }/* End get_instance_offset_without_malloc */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
Rem_time_p get_instance_offset (ev_p)
 Event_p ev_p;
 {/* Init get_instance_offset */
  int tr = GET_TRANSITION_INDEX(ev_p);
  int found = FALSE;

  Rem_time_p scan_ptr = GET_TRANSITION_TIMES_LIST(tr);
  Rem_time_p ret_ptr = NULL;

  for(; scan_ptr != NULL && !found; )
   {/* Per ogni istanza */
    if(match_identity(scan_ptr,ev_p))
     {/* Trovata la istanza */
      found = TRUE;
      ret_ptr = scan_ptr;
     }/* Trovata la istanza */
    scan_ptr = NEXT_RESIDUAL(scan_ptr);
   }/* Per ogni istanza */
  if(!found)
   {/* Non presente prima */
    ret_ptr = pop_rem_time(tr);
    copy_instance_identity(ret_ptr,ev_p);
    ret_ptr->next = GET_TRANSITION_TIMES_LIST(tr);
    tabt[tr].residual = ret_ptr;
   }/* Non presente prima */
  return(ret_ptr);
 }/* End get_instance_offset */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void insert_firing_time(tr,rem_ptr,time_v)
 int tr;
 Rem_time_p rem_ptr;
 double time_v;
 {/* Init insert_firing_time */
  Time_p scan_ptr = GET_TIMES_LIST(rem_ptr);
  Time_p ins_ptr = NULL;

  ins_ptr = pop_times();
  ins_ptr->time = time_v;
  if(scan_ptr == NULL)
   rem_ptr->times = ins_ptr;
  else
   {/* Scanning della lista dei tempi per inserzione ordinata */
    Time_p prev_ptr = NULL;

    for( ;  scan_ptr != NULL ; )
     {
      if( scan_ptr->time >= time_v )
       break;
      prev_ptr = scan_ptr;
      scan_ptr = NEXT_TIME(scan_ptr);
     }
    ins_ptr->next = scan_ptr;
    if(prev_ptr == NULL)
     rem_ptr->times = ins_ptr;
    else
     prev_ptr->next = ins_ptr;
   }/* Scanning della lista dei tempi per inserzione ordinata */
  rem_ptr->degree++;
 }/* End insert_firing_time */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void decrease_service_times(rem_ptr,ev_p)
 Rem_time_p rem_ptr;
 Event_p ev_p;
 {/* Init decrease_service_times */
  Time_p time_ptr = NULL;

  time_ptr = GET_TIMES_LIST(rem_ptr);
  for(; time_ptr != NULL ;)
   {/* Per ogni tempo schedulato per quell'istanza */
    time_ptr->time -= (cur_time - ev_p->last_sched_desched_time);
    if(GET_TIME_VALUE(time_ptr) < EPSILON)
     time_ptr->time = 0.0;
    time_ptr = NEXT_TIME(time_ptr);
   }/* Per ogni tempo schedulato per quell'istanza */
 }/* End decrease_service_times */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
double generate_firing_time(tr,ev_p)
 int tr;
 Event_p ev_p;
 {/* Init generate_firing_time */
  int i;
  double sched_time,vv;

  switch ( tabt[tr].timing	)
   {/* tipo di distribuzione */
    case TIMING_DETERMINISTIC :
#ifdef DSDR
         if(tr == DSDR_TRANS)
          {/* Transizione rate M_D */
           sched_time = (double)(M_DIST * tabt[tr].mean_t * DIST(ev_p)); 
          }/* Transizione rate M_D */
         else
#endif
	 sched_time = tabt[tr].mean_t;
	 break;
    case TIMING_IPOEXP :
	 for(i=0,vv=0.0;i<K_ERLANG;i++)
	 vv+=negexp(1.0/(K_ERLANG*tabt[tr].mean_t));
	 break;
   }/* tipo di distribuzione */
  return(sched_time);
 }/* End generate_firing_time */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void update_left_timing(ev_p)
 Event_p ev_p;
 {/* Init update_left_timing */
  int tr = GET_TRANSITION_INDEX(ev_p);

  Rem_time_p rem_ptr = NULL;

  struct REM_TIME_INFO info;
  Rem_time_info_p info_ptr = &info;

  Time_p push_ptr = NULL;

  get_instance_info(ev_p,info_ptr);
  rem_ptr = info_ptr->pos;
  push_ptr = GET_TIMES_LIST(rem_ptr);
  rem_ptr->times = rem_ptr->times->next;
  push_times(push_ptr);
  if(--(rem_ptr->degree))
   decrease_service_times(rem_ptr,ev_p);
  else
   {
    if(rem_ptr->times != NULL)
     out_error(ERROR_FIRING_TIMES_MANAGEMENT,0,tr,0,0,NULL,NULL);
    if(info_ptr->prv != NULL)
     (info_ptr->prv)->next = rem_ptr->next;
    else
     tabt[tr].residual = (info_ptr->pos)->next;
    push_rem_time(rem_ptr,tr);
   }
 }/* End update_left_timing */
#endif
